/*
Class InputExpDialog

Copyright (C) 2003 Alwen Tiu

   This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or (at
your option) any later version.

   This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

   You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software Foundation,
Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

import javax.swing.*;
import javax.swing.event.ListSelectionListener;
import javax.swing.event.ListSelectionEvent;
import java.awt.*;
import java.awt.event.*;

class InputExpDialog extends JDialog
                   implements ActionListener    {
    private boolean enter = false;
	private JTextPane inputText;
	private String exp = null;
    
	public void setInput(String s) 
	{
		inputText.setText(s);	
	} 
    public String getInput() { return exp; }
    	
	public boolean isOK() { return enter; }	
			
    public InputExpDialog(Frame aFrame) {
        super(aFrame, true);
        
       	setTitle("Input an expression");
        
        JPanel btnPanel = new JPanel();
        
        JButton btnSel = new JButton("OK");
        JButton btnCancel = new JButton("Cancel");

        btnSel.setActionCommand("OK");
        btnSel.addActionListener(this);
		btnCancel.setActionCommand("Cancel");
		btnCancel.addActionListener(this);
		        
        exp = "";
        LincDoc doc = new LincDoc();
        inputText = new JTextPane(doc);
        inputText.setText(exp);
        inputText.setCaretPosition(0);
        inputText.setMargin(new Insets(5,5,5,5));
		                
        JScrollPane inputView = new JScrollPane(inputText);
        inputView.setMinimumSize(new Dimension(400, 70));
        inputView.setPreferredSize(new Dimension(400, 100));        		
		btnPanel.add(btnSel);
		btnPanel.add(btnCancel);
		
		getContentPane().setLayout(new BorderLayout());
		getContentPane().add(inputView, BorderLayout.CENTER);
		getContentPane().add(btnPanel, BorderLayout.SOUTH);
		
    }

    
    public void actionPerformed(ActionEvent e) {
	    
        if("OK".equals(e.getActionCommand()))
        {
			  enter = true;			   
			  exp = inputText.getText();
			  
			  clearAndHide();    		        
        }
        else if("Cancel".equals(e.getActionCommand()))
        {
	        enter = false;
	    	clearAndHide();    
        }
    }

    public void clearAndHide() {
        
        setVisible(false);
    }
}

