/*
Class Sequent

Copyright (C) 2003 Alwen Tiu

   This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or (at
your option) any later version.

   This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

   You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software Foundation,
Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

import java.io.*;


public class Sequent implements Serializable
{

	protected String name, seq, rule, exp;
	protected Boolean leaf;
	protected String mainForm;
					
	public Sequent(String s)
	    {
		    rule = ""; leaf = Boolean.FALSE;
		    mainForm = "";
		    exp = "";
		    parse(s);
	    }	
	
	public Sequent(String s, String r, Boolean l)
	{
		parse(s);
		rule = r; 
		leaf = l;	
	}	    
	
	public String getName() { return name;}
	public String getSeq() { return seq;}
	public Boolean getLeaf() { return leaf;}
	public String getRule() { return rule;}
	public String getMainForm() { return mainForm; }
	public String getExp() { return exp;}
	
	public void setSeq(String s) { parse(s);}
	public void setLeaf(Boolean b) { leaf = b; }
	public void setRule(String r) { rule = r;}
	public void setMainForm(String m) { mainForm = m; }
	public void setExp(String e) { exp = e; }
	
	public static String[] parseSequents(String s)
	{
		return s.split("%");
	}

	public void parse(String s)
	{
		String[] ls;
			
		ls = s.split("\\x2E", 2);
		if(ls.length >= 1)
			name = ls[0];
		else name = "";	
		seq = s;
	}
	    
	private void writeObject(ObjectOutputStream s) throws IOException, ClassNotFoundException {
    	s.defaultWriteObject();
    	s.writeObject(mainForm);
    	s.writeObject(rule);
    	s.writeObject(exp);
    	s.writeObject(leaf);
		s.writeObject(seq);
    }
    
    private void readObject(ObjectInputStream s) throws IOException, ClassNotFoundException  {
    	s.defaultReadObject();
    	mainForm = (String) s.readObject();
		rule = (String) s.readObject();
		exp = (String) s.readObject();
		
		leaf = (Boolean) s.readObject();
		seq = (String) s.readObject();			
		parse(seq);
	}

	public String toString()
	{
		if (rule.equals("")) return "Open node";
		return rule;			
	}

}	
