% Module infer (signature file)
%
% Copyright (C) 2003 Alwen Tiu
%
%   This program is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either version 2 of the License, or (at
% your option) any later version.
% 
%   This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
% General Public License for more details.
%
%   You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software Foundation,
% Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


% Module: infer
% Author: Alwen Tiu
% Date:  8/26/03
% Description: definition of inference rules

sig infer.

accum_sig lincsig.

kind infrule type.

type inf_init, inf_top, inf_bot, inf_eqr, inf_andr, inf_defr,
     inf_orr1, inf_orr2, inf_impr, inf_pir, inf_sigmar,
     inf_coindr, inf_contrl, inf_weakl, inf_eql, inf_defl,
     inf_andl, inf_orl, inf_impl, inf_pil, inf_sigmal, 
     inf_indl, inf_defr_inst, inf_defr_one infrule.

% inference rule schemes :
% inf Rule MainFormula Conculsion Premises NumberOfPremises.

type inf infrule -> tm -> sequent -> list sequent -> int -> o.
type inff string -> infrule -> tm -> sequent -> list sequent -> int -> o.

type focus sequent -> list sequent -> int -> o.
type focus_eql sequent -> list sequent -> int -> o.

type load_def string -> defn -> o.
type load_seq string -> list sequent -> int -> o.
type get_defr_clauses sequent -> list tm -> o.

type input_fterm string -> tm -> o.
type atomic tm -> list tm -> o.

type norm_seq list signat -> sequent -> sequent -> o.
